`timescale 1ns / 1ps
`define COUNTER_MAX 255

// Varianta folosind counter
// Se pot genera semnale de ceas cu frecventa 
// cu factor de divizare de 1:2, 1:4, 1:8 folosind bitii din counter

module clk_div_varianta2(
	output reg clk_out,
	input clk_in
	);

	reg [7:0] counter;
	
	initial begin
	  counter = 0;
	  clk_out = 0;
	end

	always @(clk_in) begin
		/*
			Pentru factor de divizare 1:2, iau al doilea bit din counter, bitul counter[1]
				Bitul counter[1] isi schimba valoarea cand counter  
				clk_in == 0 	counter == 0000 0000 => 0 // toggle counter[1]
				clk_in == 1    counter == 0000 0001 => 1
				clk_in == 0 	counter == 0000 0010 => 2 // toggle counter[1]
				clk_in == 1    counter == 0000 0011 => 3
				clk_in == 0 	counter == 0000 0100 => 4 // toggle counter[1]
				clk_in == 1    counter == 0000 0101 => 5
				
				Obs: Pot selecta un alt bit pentru un factor de divizare diferit
					  counter[2] -> factor de divizare 1:4
		*/
		clk_out = counter[1]; 
		if (counter  == `COUNTER_MAX) begin
			counter = 0;
		end else begin
			counter = counter + 1;
		end
		
	end

endmodule
 